#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "globs.h"
#include "pdf417_enc.h"


  void test_byte_compact()
  {

  char this_string[120];

    printf(" String = 'AB'  result 901, 171 \n");

    this_string[0] = 'A';
    this_string[1] = 'B';

    this_string[2] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = 'ABABCF' result 901, 171, 171, 207 \n");

    this_string[0] = 'A';
    this_string[1] = 'B';
    this_string[2] = 'A';
    this_string[3] = 'B';
    this_string[4] = 'C';
    this_string[5] = 'F';

    this_string[6] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = 'FFFFFF' result 901, 255, 255, 255 \n");

    this_string[0] = 'F';
    this_string[1] = 'F';
    this_string[2] = 'F';
    this_string[3] = 'F';
    this_string[4] = 'F';
    this_string[5] = 'F';
    this_string[6] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = '1000000' result 901, 1, 0, 0, 0 \n");

    this_string[0] = '1';
    this_string[1] = '0';
    this_string[2] = '0';
    this_string[3] = '0';
    this_string[4] = '0';
    this_string[5] = '0';
    this_string[6] = '0';
    this_string[7] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = '384' result 901, 3, 132  \n");

    this_string[0] = '3';
    this_string[1] = '8';
    this_string[2] = '4';
    this_string[3] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = '384000000' result 901, 3, 132, 0, 0, 0 \n");

    this_string[0] = '3';
    this_string[1] = '8';
    this_string[2] = '4';
    this_string[3] = '0';
    this_string[4] = '0';
    this_string[5] = '0';
    this_string[6] = '0';
    this_string[7] = '0';
    this_string[8] = '0';
    this_string[9] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = 'C5C10000000' result 924, 20, 641, 316, 0, 0  \n");

    this_string[0] = 'C';
    this_string[1] = '5';
    this_string[2] = 'C';
    this_string[3] = '1';
    this_string[4] = '0';
    this_string[5] = '0';
    this_string[6] = '0';
    this_string[7] = '0';
    this_string[8] = '0';
    this_string[9] = '0';
    this_string[10] = '0';
    this_string[11] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = 'FFFFFFFFFFFF' result 924, 429, 11, 71, 222, 855  \n");

    this_string[0] = 'F';
    this_string[1] = 'F';
    this_string[2] = 'F';
    this_string[3] = 'F';
    this_string[4] = 'F';
    this_string[5] = 'F';
    this_string[6] = 'F';

    this_string[7] = 'F';
    this_string[8] = 'F';
    this_string[9] = 'F';
    this_string[10] = 'F';
    this_string[11] = 'F';
    this_string[12] = NULLCHAR;


    byte_compact(this_string);

    printf(" String = 'FFFFFFFFFFFFFF' result 901,  429, 11, 71, 222, 855, 255 \n");

    this_string[0] = 'F';
    this_string[1] = 'F';
    this_string[2] = 'F';
    this_string[3] = 'F';
    this_string[4] = 'F';
    this_string[5] = 'F';
    this_string[6] = 'F';

    this_string[7] = 'F';
    this_string[8] = 'F';
    this_string[9] = 'F';
    this_string[10] = 'F';
    this_string[11] = 'F';
    this_string[12] = 'F';
    this_string[13] = 'F';
    this_string[14] = NULLCHAR;

    byte_compact(this_string);

    printf(" String = 'FF655BFBAC00' result 901,  428, 0, 0, 0, 0 \n");

    /*  FF655BFBAC00  = 428 * 900 ^ 4 */

    this_string[0] = 'F';
    this_string[1] = 'F';
    this_string[2] = '6';
    this_string[3] = '5';
    this_string[4] = '5';
    this_string[5] = 'B';
    this_string[6] = 'F';

    this_string[7] = 'B';
    this_string[8] = 'A';
    this_string[9] = 'C';
    this_string[10] = '0';
    this_string[11] = '0';
    this_string[12] = NULLCHAR;

    byte_compact(this_string);


  }


  void test_nc()
  {

  char this_string[120];

    printf(" String = '12' Result = 112 \n");

    this_string[0] = '1';
    this_string[1] = '2';
    this_string[2] = NULLCHAR;

    nc(this_string);

    printf(" String = '199' Result = 1, 299 \n");

    this_string[0] = '1';
    this_string[1] = '9';
    this_string[2] = '9';
    this_string[3] = NULLCHAR;

    nc(this_string);


    printf(" String = '81030499' Result = 223, 444, 899 \n");

    this_string[0] = '8';
    this_string[1] = '1';
    this_string[2] = '0';
    this_string[3] = '3';
    this_string[4] = '0';
    this_string[5] = '4';
    this_string[6] = '9';
    this_string[7] = '9';
    this_string[8] = NULLCHAR;


    nc(this_string);

    printf(" String = '999999999999999999999999999999999' Result = 874, \n");
    printf("                  223, 532, 264, 888, 236, 358, 185, 93, \n");
    printf("                  795, 72, 289, 146, 822, 199 \n");



    this_string[0] = '9';
    this_string[1] = '9';
    this_string[2] = '9';
    this_string[3] = '9';
    this_string[4] = '9';
    this_string[5] = '9';
    this_string[6] = '9';
    this_string[7] = '9';
    this_string[8] = '9';
    this_string[9] = '9';
    this_string[10] = '9';
    this_string[11] = '9';
    this_string[12] = '9';
    this_string[13] = '9';
    this_string[14] = '9';
    this_string[15] = '9';
    this_string[16] = '9';
    this_string[17] = '9';
    this_string[18] = '9';
    this_string[19] = '9';
    this_string[20] = '9';
    this_string[21] = '9';
    this_string[22] = '9';
    this_string[23] = '9';
    this_string[24] = '9';
    this_string[25] = '9';
    this_string[26] = '9';
    this_string[27] = '9';
    this_string[28] = '9';
    this_string[29] = '9';
    this_string[30] = '9';
    this_string[31] = '9';
    this_string[32] = '9';
    this_string[33] = '9';
    this_string[34] = '9';
    this_string[35] = '9';
    this_string[36] = '9';
    this_string[37] = '9';
    this_string[38] = '9';
    this_string[39] = '9';
    this_string[40] = '9';
    this_string[41] = '9';
    this_string[42] = '9';
    this_string[43] = '9';
    this_string[44] = NULLCHAR;
    
    nc(this_string);

    printf(" String = '83392052934923097837839823098730398238723982' Result = 801, \n");
    printf("      585, 871, 712, 484, 159, 13, 622, 183, 750 \n");
    printf("      548, 487, 513, 215, 482 \n");
    this_string[0] = '8';
    this_string[1] = '3';
    this_string[2] = '3';
    this_string[3] = '9';
    this_string[4] = '2';
    this_string[5] = '0';
    this_string[6] = '5';
    this_string[7] = '2';
    this_string[8] = '9';
    this_string[9] = '3';
    this_string[10] = '4';
    this_string[11] = '9';
    this_string[12] = '2';
    this_string[13] = '3';
    this_string[14] = '0';
    this_string[15] = '9';
    this_string[16] = '7';
    this_string[17] = '8';
    this_string[18] = '3';
    this_string[19] = '7';
    this_string[20] = '8';
    this_string[21] = '3';
    this_string[22] = '9';
    this_string[23] = '8';
    this_string[24] = '2';
    this_string[25] = '3';
    this_string[26] = '0';
    this_string[27] = '9';
    this_string[28] = '8';
    this_string[29] = '7';
    this_string[30] = '3';
    this_string[31] = '0';
    this_string[32] = '3';
    this_string[33] = '9';
    this_string[34] = '8';
    this_string[35] = '2';
    this_string[36] = '3';
    this_string[37] = '8';
    this_string[38] = '7';
    this_string[39] = '2';
    this_string[40] = '3';
    this_string[41] = '9';
    this_string[42] = '8';
    this_string[43] = '2';
    this_string[44] = NULLCHAR;
    
    nc(this_string);

    printf("End test nc \n");

  }

  void test_text_comp()
  {


  char tstring[120];


    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = BACKSLASH;
    tstring[3] = 'N';
    tstring[4] = 'L';

    tstring[5] = NULLCHAR;


    expand_string( tstring);

    printf("Expanded string = %s \n", tstring);



    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = BACKSLASH;
    tstring[3] = 'C';
    tstring[4] = 'R';

    tstring[5] = NULLCHAR;


    expand_string( tstring);

    printf("Expanded string = %s \n", tstring);



    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = BACKSLASH;
    tstring[3] = 'L';
    tstring[4] = 'F';

    tstring[5] = NULLCHAR;


    expand_string( tstring);

    printf("Expanded string = %s \n", tstring);



    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = BACKSLASH;
    tstring[3] = 'B';
    tstring[4] = 'S';

    tstring[5] = NULLCHAR;


    expand_string( tstring);

    printf("Expanded string = %s \n", tstring);


    printf("\n");
    printf(" string = ABCD  expect 1, 63 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'D';

    tstring[4] = NULLCHAR;


    text_compress( tstring);

    printf("\n");
    printf(" string = ABCDE  expect 1, 63, 149 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'D';
    tstring[4] = 'E';

    tstring[5] = NULLCHAR;


    text_compress( tstring);

  printf("\n");
    printf(" string = ABCDEF  expect 1, 63, 125 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'D';
    tstring[4] = 'E';

    tstring[5] = 'F';
    tstring[6] = NULLCHAR;



    text_compress( tstring);

  printf("\n");
    printf(" string = ABCabc  expect 1, 87 (2 *30 + 27), 1, 89 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'a';
    tstring[4] = 'b';

    tstring[5] = 'c';
    tstring[6] = NULLCHAR;



    text_compress( tstring);

  printf("\n");
    printf(" string = ABCDabc  expect 1, 63, 810 (27 * 30), 32 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'D';
    tstring[4] = 'a';
    tstring[5] = 'b';

    tstring[6] = 'c';
    tstring[7] = NULLCHAR;


    text_compress( tstring);

  printf("\n");
    printf(" string = ABCDabcd  expect 1, 63, 810 (27 * 30), 32, 119 \n");

    tstring[0] = 'A';
    tstring[1] = 'B';
    tstring[2] = 'C';
    tstring[3] = 'D';
    tstring[4] = 'a';
    tstring[5] = 'b';
    tstring[6] = 'c';
    tstring[7] = 'd';
    tstring[8] = NULLCHAR;



    text_compress( tstring);

  printf("\n");
    printf(" string = abcdef  expect 810( 27 * 30), 32, 94, 179 \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = 'e';
    tstring[5] = 'f';
    tstring[6] = NULLCHAR;

    text_compress( tstring);


    printf("\n");
    printf(" string = abcDEf  expect 810 (27 * 30), 32, 868, 94, 815 \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'D';
    tstring[4] = 'E';

    tstring[5] = 'f';
    tstring[6] = NULLCHAR;

    text_compress( tstring);


    printf("\n");
 printf(" string = abc,gh  exp 810, 32, 853( 840 + 13), 816( 810 + 6), (210 + 39) 239 \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = ',';
    tstring[4] = 'g';

    tstring[5] = 'h';
    tstring[6] = NULLCHAR;



    text_compress( tstring);


  printf("\n");
    printf(" string = abcd,gh  expect 810, 32, 118, 417(390 + 27), 187(180+7) \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = ',';
    tstring[5] = 'g';

    tstring[6] = 'h';
    tstring[7] = NULLCHAR;



    text_compress( tstring);


  printf("\n");
    printf(" string = abcd<gh  expect 810, 32, 118, 897(870 + 27), 187 \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = '<';
    tstring[5] = 'g';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;

    text_compress( tstring);


    printf("\n");
    printf(" string = abc<gh  expect 810, 32, 865(840 + 25), 59(30+29), 816, 239(210 + 29)\n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '<';
    tstring[4] = 'g';

    tstring[5] = 'h';
    tstring[6] = NULLCHAR;



    text_compress( tstring);

    printf("\n");
    printf(" string = abcAgh  expect 810,32, 868(840+28),27,187 \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'A';
    tstring[4] = 'g';
    tstring[5] = 'h';
    tstring[6] = NULLCHAR;

    text_compress( tstring);

    printf("\n");
    printf(" string = abcdAh  expect 810, 32, 118(90+38),840,817(810+7) \n");

    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = 'A';
    tstring[5] = 'h';
    tstring[6] = NULLCHAR;
    text_compress( tstring);


    printf("\n");
    printf(" string = abcd3gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = '3';
    tstring[5] = 'g';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;
    text_compress( tstring);

    printf("\n");
    printf(" string = abcd34gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = '3';
    tstring[5] = '4';
    tstring[6] = 'g';
    tstring[7] = 'h';
    tstring[8] = NULLCHAR;
    text_compress( tstring);

    printf("\n");
    printf(" string = abc3gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '3';
    tstring[4] = 'g';
    tstring[5] = 'h';
    tstring[6] = NULLCHAR;
    text_compress( tstring);

    printf("\n");
    printf(" string = abc34gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '3';
    tstring[4] = '4';
    tstring[5] = 'g';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;
    text_compress( tstring);

    printf("\n");
    printf(" string = abc34Gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '3';
    tstring[4] = '4';
    tstring[5] = 'G';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;
    text_compress( tstring);
    

    printf("\n");
    printf(" string = abc3Gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '3';
    tstring[4] = 'G';
    tstring[5] = 'h';
    tstring[6] = NULLCHAR;
    text_compress( tstring);
    

    printf("\n");
    printf(" string = abcd3Gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = 'd';
    tstring[4] = '3';
    tstring[5] = 'G';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;
    text_compress( tstring);

    printf("\n");
    printf(" string = abcd3Gh  expect 810, 32, 118(90+38),840,817(810+7) \n");
    tstring[0] = 'a';
    tstring[1] = 'b';
    tstring[2] = 'c';
    tstring[3] = '<';
    tstring[4] = '3';
    tstring[5] = 'G';
    tstring[6] = 'h';
    tstring[7] = NULLCHAR;
    text_compress( tstring);
    
    


  }  /* test text compression */

void test_ecc()
  {
int j;
 int save_val;
 int save_val2;
 int save_val3;
 int save_val4;
 int save_val5;
 int save_val6;

 int savevals[64];

 int k;
 int this_error;
 int this_error2;
 
 int randint;
 int randint2;
 int randint3;
 int randint4;
 int randint5;
 int randint6;
 
 int randin[64];

 int randloc2;
 int randloc3;
 int randloc4;
 int randloc5;
 
 int randloc;

 int difval;
 int difval2;
 int difval3;
 int difval4;
 int difval5;
 int difval6;
 int haserror;

 int difvals[64];

  data[0] = 0;   // 80
  data[1] = 0;  // 924
  data[2] = 0; 
  data[3] = 9; 
  data[4] = 334; 
  data[5] = 508; 
  data[6] = 496; 
  data[7] = 900; 
  data[8] = 840; 
  data[9] = 182; 
  data[10] = 858; 
  data[11] = 877; 
  data[12] = 924; 
  data[13] = 248; 
  data[14] = 44;
  data[15] = 50;
  data[16] = 62;
  data[17] = 572;
  data[18] = 16;
  data[19] = 683;
  data[20] = 304;
  data[21] = 781;
  data[22] = 321;
  data[23] = 17;
  data[24] = 71;
  data[25] = 175;
  data[26] = 89;
  data[27] = 365;
  data[28] = 0;
  data[29] = 594;
  data[30] = 844;
  data[31] = 351;
  data[32] = 720;
  data[33] = 163;
  data[34] = 128;
  data[35] = 227;
  data[36] = 810;
  data[37] = 552;
  data[38] = 349;
  data[39] = 422;
  data[40] = 462;
  data[41] = 861;
  data[42] = 733;
  data[43] = 80;
  data[44] = 681;
  data[45] = 553;
  data[46] = 501;
  data[47] = 669;
  data[48] = 0;
  data[49] = 439;
  data[50] = 484;
  data[51] = 888;
  data[52] = 103;
  data[53] = 349;
  data[54] = 133;
  data[55] = 113;
  data[56] = 116;
  data[57] = 757;
  data[58] = 221;
  data[59] = 781;
  data[60] = 645;
  data[61] = 562;
  data[62] = 333;
  data[63] = 16;
  data[64] = 134;
  data[65] = 279;
  data[66] = 497;
  data[67] = 660;
  data[68] = 371;
  data[69] = 110;
  data[70] = 857;
  data[71] = 319;
  data[72] = 593;
  data[73] = 370;
  data[74] = 700;
  data[75] = 488;
  data[76] = 30;
  data[77] = 149;
  data[78] = 900;         
  data[79] = 900;

  codeindex = 80;

  generateEC(  data, 80, 64 );  /* do the error correction, 64  */

  syndromes( 144, 32 );    // total data = 144 codes, 32 syndromes */

  for (j = 0; j < 144; j += 1)
    {
      erase_posit[j] = 0;
    }

  eras_dec_rs( data, erase_posit, 0 , 144, 32);   

  for(j =0; j < 64; j += 1)
    {
      printf("data[%d] =  %d \n", 80 + j, data[80+j]);

    }

  codeindex = 80;

  generateEC(  data, 80, 64 );  /* do the error correction, 64  */

  data[76] = 5;  // cause an error in the recieved data...

  syndromes( 144, 32 );    // total data = 144 codes, 32s syndromes */

 
  for (j = 0; j < 144; j += 1)
    {
      erase_posit[j] = 0;
    }

  printf("before data[76] = %d \n", data[76]);

  
  eras_dec_rs( data, erase_posit, 0, 144, 32);   

  printf("after data[76] = %d \n", data[76]);

   data[76] = 30;

  for ( k = 0 ; k < 80 ; k += 1)
    {
      this_error = data[k] - 5;
      save_val = data[k];
      data[k] = 5;         // cause error at location k
      
      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if (data[k] != save_val)
        {
	  printf(" Error at k = %d data[k] = %d save = %d \n", 
		 k , data[k], save_val );
        }
      data[k] = save_val;
    }

  // test random single errors

  for ( k = 0 ; k < 100 ; k += 1)
    {
      randint = rand();
      randint = randint & 1023;
      difval = randint %929;

      if ( difval > data[5])
        {
          
         this_error = difval - data[5];
	}
      else
	{
	  this_error = data[5] - difval;
        }

      save_val = data[5];
      data[5] = difval;    // cause error at location k
      
   
      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if (data[5] != save_val)
        {
	  printf(" Error at k = %d data[k] = %d save = %d \n", 
		 k , data[5], save_val );
        }
      data[5] = save_val;
    }

  // simple double errors

  printf("Begin random double errors \n");

  data[0] = 0;   // 80
  data[1] = 0;  // 924
  data[2] = 0; 
  data[3] = 9; 
  data[4] = 334; 
  data[5] = 508; 
  data[6] = 496; 
  data[7] = 900; 
  data[8] = 840; 
  data[9] = 182; 
  data[10] = 858; 
  data[11] = 877; 
  data[12] = 924; 
  data[13] = 248; 
  data[14] = 44;
  data[15] = 50;
  data[16] = 62;
  data[17] = 572;
  data[18] = 16;
  data[19] = 683;
  data[20] = 304;
  data[21] = 781;
  data[22] = 321;
  data[23] = 17;
  data[24] = 71;
  data[25] = 175;
  data[26] = 89;
  data[27] = 365;
  data[28] = 0;
  data[29] = 594;
  data[30] = 844;
  data[31] = 351;
  data[32] = 720;
  data[33] = 163;
  data[34] = 128;
  data[35] = 227;
  data[36] = 810;
  data[37] = 552;
  data[38] = 349;
  data[39] = 422;
  data[40] = 462;
  data[41] = 861;
  data[42] = 733;
  data[43] = 80;
  data[44] = 681;
  data[45] = 553;
  data[46] = 501;
  data[47] = 669;
  data[48] = 0;
  data[49] = 439;
  data[50] = 484;
  data[51] = 888;
  data[52] = 103;
  data[53] = 349;
  data[54] = 133;
  data[55] = 113;
  data[56] = 116;
  data[57] = 757;
  data[58] = 221;
  data[59] = 781;
  data[60] = 645;
  data[61] = 562;
  data[62] = 333;
  data[63] = 16;
  data[64] = 134;
  data[65] = 279;
  data[66] = 497;
  data[67] = 660;
  data[68] = 371;
  data[69] = 110;
  data[70] = 857;
  data[71] = 319;
  data[72] = 593;
  data[73] = 370;
  data[74] = 700;
  data[75] = 488;
  data[76] = 30;
  data[77] = 149;
  data[78] = 900;         
  data[79] = 900;

  // one random error at 0 and error of 1 at 1

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
      randint = randint & 1023;
      difval = randint %929;

      if ( difval > data[0])
        {
          
         this_error = difval - data[0];
	}
      else
	{
	  this_error = data[0] - difval;
        }

      save_val = data[0];
      data[0] = difval;    // cause error at location k
    
      save_val2 = data[1];
      data[1] = 1;
   
      printf("Data [0,1] = %d %d \n", data[0], data[1]);

      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if ( (data[0] != save_val) | ( data[1] != save_val2))
        {
	  printf(" Error at k = %d data[0] = %d save = %d \n", 
		 k , data[0], save_val );
          printf(" Error2 at k = %d data[1] = %d save = %d \n", 
		 k , data[1], save_val2 );
        }
      data[0] = save_val;
      data[1] = save_val2;
    }

  // random error at random loc and error at 1

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
      randint = randint & 1023;
      difval = randint %929;

      randloc = rand();
      randloc = randloc % 80;

      if (randloc == 1)
	{
          randloc += 1;
        }

      if ( difval > data[randloc])
        {
          
         this_error = difval - data[randloc];
	}
      else
	{
	  this_error = data[randloc] - difval;
        }

      save_val = data[randloc];
      data[randloc] = difval;    // cause error at location k
    
      save_val2 = data[1];
      data[1] = 1;
   
      printf("Data [randloc,1] = %d %d \n", data[randloc], data[1]);

      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if ( (data[randloc] != save_val) | ( data[1] != save_val2))
        {
	  printf(" Error at k = %d data[randloc] = %d save = %d \n", 
		 k , data[randloc], save_val );
          printf(" Error2 at k = %d data[1] = %d save = %d \n", 
		 k , data[1], save_val2 );
        }
      data[randloc] = save_val;
      data[1] = save_val2;
    }

  // two random errors at random locs

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
       randint2 = rand();
      randint = randint & 1023;
      randint2 = randint2 & 1023;
      difval = randint %929;
      difval2 = randint2 % 929;


      randloc = rand();
      randloc = randloc % 80;

      randloc2 = rand();
      randloc2 = randloc % 80;

      if (randloc == randloc2)
	{
          randloc = (randloc+ 1)%929;
        }

      if ( difval > data[randloc])
        {
          
         this_error = difval - data[randloc];
	}
      else
	{
	  this_error = data[randloc] - difval;
        }

      save_val = data[randloc];
      data[randloc] = difval;    // cause error at location k
    
      save_val2 = data[1];


      if ( difval2 > data[randloc2])
        {
          
         this_error2 = difval2 - data[randloc2];
	}
      else
	{
	  this_error2 = data[randloc2] - difval2;
        }

      save_val2 = data[randloc2];
      data[randloc2] = difval2;    // cause error at location k
    
   
      printf("Data [randloc,randloc2] = %d %d \n", data[randloc], data[randloc2]);

      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if ( (data[randloc] != save_val) || ( data[randloc2] != save_val2))
        {
	  printf(" Error at k = %d data[randloc] = %d save = %d \n", 
		 k , data[randloc], save_val );
          printf(" Error2 at k = %d data[randloc2] = %d save = %d \n", 
		 k , data[randloc2], save_val2 );
        }
      data[randloc] = save_val;
      data[randloc2] = save_val2;
    }

  for(j =0; j < 64; j += 1)
    {
      printf("data[%d] =  %d \n", 80 + j, data[80+j]);

    }

  // three random errors at random locs

  printf("Begin random triple errors \n");

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
       randint2 = rand();
       randint3 = rand();

      randint = randint & 1023;
      randint2 = randint2 & 1023;
      randint3 = randint3 & 1023;

      difval = randint %929;
      difval2 = randint2 % 929;
      difval3 = randint3 % 929;

      randloc = rand();
      randloc = randloc % 80;
      

      randloc2 = rand();
      randloc2 = randloc % 80;

      if ( randloc2 > randloc)
        {
	  if (randloc2 - randloc != 1)
            {
              if ((randloc2 - randloc) % 2 == 0)
                {
                  randloc3 = (randloc2 - randloc)/2;
                }
              else
                {
                  randloc3 = ( 1 + randloc2 - randloc)/2;
                }
	    }
        }
      else   // randloc2 < or = randloc1
        {
          if (randloc2 != 0)
	    {
	      randloc3 = randloc2 - 1;
            }               
          else
            {
	      randloc3 = (randloc + 1) % 929;
            }
	}

      if (randloc == randloc2)
	{
          randloc = (randloc+ 1)%929;
        }

      if ( difval > data[randloc])
        {
          
         this_error = difval - data[randloc];
	}
      else
	{
	  this_error = data[randloc] - difval;
        }

      save_val = data[randloc];
      data[randloc] = difval;    // cause error at location k


      if ( difval2 > data[randloc2])
        {
          
         this_error2 = difval2 - data[randloc2];
	}
      else
	{
	  this_error2 = data[randloc2] - difval2;
        }

      save_val2 = data[randloc2];
      data[randloc2] = difval2;    // cause error at location k

      save_val3 = data[randloc3];
      data[randloc3] = difval3;    // cause error at location k
    
   
      printf("Data [randloc,randloc2,randloc3] = %d %d %d\n", data[randloc], data[randloc2], data[randloc3] );

      syndromes( 144, 32);
  
      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      if ( (data[randloc] != save_val) || ( data[randloc2] != save_val2)
              || ( data[randloc3] != save_val3 ))
        {
	  printf(" Error at k = %d data[randloc] = %d save = %d \n", 
		 k , data[randloc], save_val );
          printf(" Error2 at k = %d data[randloc2] = %d save = %d \n", 
		 k , data[randloc2], save_val2 );
          printf(" Error3 at k = %d data[randloc3] = %d save = %d \n", 
		 k , data[randloc3], save_val3 );
        }
      data[randloc] = save_val;
      data[randloc2] = save_val2;
      data[randloc3] = save_val3;
    }

  for(j =0; j < 64; j += 1)
    {
      printf("data[%d] =  %d \n", 80 + j, data[80+j]);

    }

  // three random errors at random locs, error at 76

  printf("Begin random quad errors \n");

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
       randint2 = rand()+ 17;
       randint3 = rand()-12;
       randint4 = rand()+74;

      randint = randint & 1023;
      randint2 = randint2 & 1023;
      randint3 = randint3 & 1023;
      randint4 = randint4 & 1023;

      difval = randint %929;
      difval2 = randint2 % 929;
      difval3 = randint3 % 929;
      difval4 = randint4 % 929;

      save_val = data[33];
      data[33] = difval;    // cause error at location k

      save_val2 = data[34];
      data[34] = difval2;    // cause error at location k

      save_val3 = data[35];
      data[35] = difval3;    // cause error at location k

      save_val4 = data[36];
      data[36] = difval4;    // cause error at location k

      printf("Data [33,34,35,36] = %d %d %d %d\n",
       data[33], data[34], data[35], data[36] );

      syndromes( 144, 32);
  
      printf("Done with syndromes \n");

      eras_dec_rs( data, erase_posit, 0, 144, 32 );
      
      printf("Returned from eras_dec_rs \n");

      if ( (data[33] != save_val) || ( data[34] != save_val2)
        || ( data[35] != save_val3 ) || ( data[36] != save_val4))
        {
          
		
	  printf(" Error at k = %d data[33] = %d save = %d \n", 
		 k , data[33], save_val );
          printf(" Error2 at k = %d data[34] = %d save = %d \n", 
		 k , data[34], save_val2 );
          printf(" Error3 at k = %d data[35] = %d save = %d \n", 
		 k , data[randloc3], save_val3 );
          printf(" Error4 at k = %d data[36] = %d save = %d \n", 
		 k , data[36], save_val4);
        }
      data[33] = save_val;
      data[34] = save_val2;
      data[35] = save_val3;
      data[36] = save_val4;
    }

  codeindex = 80;

  generateEC(  data, 80, 128 );  /* do the error correction, 128 */

  syndromes( 208, 64);

  for (j = 0; j < 208; j += 1)
    {
      erase_posit[j] = 0;
    }

  //

  printf("Begin random errors for level 6 ecc\n");

  for ( k = 0 ; k < 100 ; k += 1)
    {
      for ( j = 0; j < 64; j += 1)
	{
	  randin[j] = rand();
        }

      for ( j = 0; j < 64; j += 1)
	{
	  randin[j] = randin[j] & 1023;
          difvals[j] = randin[j] % 929;
        }
      for ( j = 0; j < 64; j += 1)
        {
          savevals[j] = data[13+j];
          data[33+j] = difvals[j];
        }


      syndromes( 208, 64);
  
      printf("Done with syndromes \n");

      eras_dec_rs( data, erase_posit, 0, 208, 64 );
      
      printf("Returned from eras_dec_rs \n");

      haserror = FALSE;

      for ( j = 0; j < 64; j += 1)
        {
          if ( data[13+j] != savevals[j])
            {
	      haserror = TRUE;
            }
        }
      if ( haserror == TRUE )
      
        {
      		
	  printf("Error:  Level 6 ecc failed \n");
 
        }
   
      for ( j = 0; j < 64; j += 1)
	{
	  data[13+j] = savevals[j];
        }

    }

  codeindex = 80;

  generateEC(  data, 80, 256 );  /* do the error correction, 256 */

  syndromes( 336, 128);

  for (j = 0; j < 336; j += 1)
    {
      erase_posit[j] = 0;
    }

  //

  printf("Begin random  six errors \n");

  for ( k = 0 ; k < 100 ; k += 1)
    {

       randint = rand();
       randint2 = rand()+ 17;
       randint3 = rand()-12;
       randint4 = rand()+74;
       randint5 = rand()-11;
       randint6 = rand()+12;

      randint = randint & 1023;
      randint2 = randint2 & 1023;
      randint3 = randint3 & 1023;
      randint4 = randint4 & 1023;
      randint5 = randint5 & 1023;
      randint6 = randint6 & 1023;

      difval = randint % 929;
      difval2 = randint2 % 929;
      difval3 = randint3 % 929;
      difval4 = randint4 % 929;
      difval5 = randint5 % 929;
      difval6 = randint6 & 929;

      save_val = data[33];
      data[33] = difval;    // cause error at location k

      save_val2 = data[34];
      data[34] = difval2;    // cause error at location k

      save_val3 = data[35];
      data[35] = difval3;    // cause error at location k

      save_val4 = data[36];
      data[36] = difval4;    // cause error at location k

      save_val5 = data[37];
      data[37] = difval5;    // cause error at location k

      save_val6 = data[38];
      data[38] = difval6;    // cause error at location k

      printf("Data [33,34,35,36,37, 38] = %d %d %d %d %d %d\n",
       data[33], data[34], data[35], data[36], data[37], data[38] );

      syndromes( 336, 128);
  
      printf("Done with syndromes \n");

      eras_dec_rs( data, erase_posit, 0, 208, 64 );
      
      printf("Returned from eras_dec_rs \n");

      if ( (data[33] != save_val) || ( data[34] != save_val2)
        || ( data[35] != save_val3 ) || ( data[36] != save_val4) ||
            ( data[37] != save_val5) || ( data[38] != save_val6))
        {
          
		
	  printf(" Error at k = %d data[33] = %d save = %d \n", 
		 k , data[33], save_val );
          printf(" Error2 at k = %d data[34] = %d save = %d \n", 
		 k , data[34], save_val2 );
          printf(" Error3 at k = %d data[35] = %d save = %d \n", 
		 k , data[randloc3], save_val3 );
          printf(" Error4 at k = %d data[36] = %d save = %d \n", 
		 k , data[36], save_val4);
          printf(" Error5 at k = %d data[37] = %d save = %d \n", 
		 k , data[36], save_val5);
          printf(" Error6 at k = %d data[38] = %d save = %d \n", 
		 k , data[38], save_val6);
        }
      data[33] = save_val;
      data[34] = save_val2;
      data[35] = save_val3;
      data[36] = save_val4;
      data[37] = save_val5;
      data[38] = save_val6;
    }

  for(j =0; j < 64; j += 1)
    {
      printf("data[%d] =  %d \n", 80 + j, data[80+j]);

    }

  /*
  data[79] = 80; 
  data[78] = 924; 
  data[77] = 0; 
  data[76] = 9; 
  data[75] = 334; 
  data[74] = 508; 
  data[73] = 496; 
  data[72] = 900; 
  data[71] = 840; 
  data[70] = 182; 
  data[69] = 858; 
  data[68] = 877; 
  data[67] = 924; 
  data[66] = 248; 
  data[65] = 44;
  data[64] = 50;
  data[63] = 62;
  data[62] = 572;
  data[61] = 16;
  data[60] = 683;
  data[59] = 304;
  data[58] = 781;
  data[57] = 321;
  data[56] = 17;
  data[55] = 71;
  data[54] = 175;
  data[53] = 89;
  data[52] = 365;
  data[51] = 0;
  data[50] = 594;
  data[49] = 844;
  data[48] = 351;
  data[47] = 720;
  data[46] = 163;
  data[45] = 128;
  data[44] = 227;
  data[43] = 810;
  data[42] = 552;
  data[41] = 349;
  data[40] = 422;
  data[39] = 462;
  data[38] = 861;
  data[37] = 733;
  data[36] = 80;
  data[35] = 681;
  data[34] = 553;
  data[33] = 501;
  data[32] = 669;
  data[31] = 0;
  data[30] = 439;
  data[29] = 484;
  data[28] = 888;
  data[27] = 103;
  data[26] = 349;
  data[25] = 133;
  data[24] = 113;
  data[23] = 116;
  data[22] = 757;
  data[21] = 221;
  data[20] = 781;
  data[19] = 645;
  data[18] = 562;
  data[17] = 333;
  data[16] = 16;
  data[15] = 134;
  data[14] = 279;
  data[13] = 497;
  data[12] = 660;
  data[11] = 371;
  data[10] = 110;
  data[9] = 857;
  data[8] = 319;
  data[7] = 593;
  data[6] = 370;
  data[5] = 700;
  data[4] = 488;
  data[3] = 30;
  data[2] = 147;
  data[1] = 900;         
  data[0] = 900;

  generateEC(  data, 80, 64 ); 

  for(j =0; j < 64; j += 1)
    {
      printf("data[%d] =  %d \n", 80 + j, data[80+j]);

    }
    */
}

